#!/bin/bash
MBINS=/opt/local/bin
[ ! -d $MBINS ] && MBINS=/root/my-applications/bin
# $MBINS/htpdate-0.4.sh
# With link in: / Avec lien dans : /root/Startup
# -=> Actually lives now as /etc/init.d/start_htpdate-0.3.sh. <=-
#
# Goal: Sync the time data of your Puppy by probing http sites. /#
# Objectif : Synchroniser le temps et l'heure de votre Toutou ou
# ---------- Puppy en sondant des sites http.
#
# Requis : htpdate (dans l'archive pet contenant ce script),
# -------- hwclock et grep (déjà dans votre Puppy ou Toutou). /#
# Required: htpdate (in the pet archive containing this script),
# --------- hwclock and grep (already in your Pup).
#
# Please read the NOTE below. / S.v.p. lire la NOTE ci-dessous.
#
# © Christian L'Écuyer, Gatineau (Qc), Canada, 27 déc. 2018. GPL3.
# (Alias musher0 [forum Puppy].) Rév. 0.2 : 28 déc. 2018.
# Rév. 03 : 28 déc. 2018. # Rév. 04. : 19 avril 2019.
# # https://opensource.org/licenses/GPL-3.0
#### set -xe
if [ -f /usr/sbin/htpdate ];then
	HwClocK="`hwclock -r`"
	if [ "`date '+%Y-%m-$d %R:%S'`" != "`hwclock -r | awk -F"." '{ print $1 }'`" ];then
		if [ -f /root/last-date ];then
			date --set="`cat /root/last-date`" # See line 25.
		else
			date --set="20181227 14:28" # arbitrary date not far in the past
		fi
		htpdate -ast www.linux.org www.freebsd.org unix.stackexchange.com puppylinux.com www.gnu.org www.cnrs.fr www.assnat.qc.ca www.parl.ca www.startpage.com
		# "$List"
		sleep 0.5s
		date '+%Y%m%d %R' > /root/last-date
		sleep 1s
		hwclock --set --date="`cat ~/last-date`"
	fi
else
	case "${LANG:0:2}" in
		fr) MsG="Veuillez installer l'utilitaire htpdate." ;;
		en|*)MsG="Please install the htpdate utility." ;;
	esac
	echo -e "\n\t$MsG\n"
fi
# set +xe
exit

#~~~~~~~~~~~~~~
#~~ NOTE ~~
#~~~~~~~~~~~
#~~~ EN ~~~
# The hwclock "check and set" routine at lines 24-25 and 35 is needed
# to allow setting the time for the user's entire session.

# Replaces /usr/local/ptimesync and /root/Startup/timesync.sh
# (please remove or store out of the way) in slacko-700_32-bits.

# As it is, this script should offer a precision between 0.6 and
# 0.167 of a second.

# I am using the sites of the Parliament of Canada and of Québec's
# National Assembly as time servers. If checking those sites take too
# much time because they are too far away, please feel free to
# test and incorporate in the htpdate URL series above other
# public or governmental sites closer to your location.

# This script will prove useful if your computer battery is dead.

# IMPORTANT: After a power outage or any sudden break of the OS, this
# script may fail. >To restore normal operation of this script,
# open a console and type, exactly:
# `grep htpdate htpdate-0.3.sh | grep -v "#"`
# rerun this script and then reboot.

#~~~~~~~~~~~~~~
## GPL3 LICENCE --
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#     This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#     You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##########

#~~~~~~~~~~~~~~
#~~~ FR ~~~
# Il faut vérifier et définir la date et l'heure avec hwclock aux
# lignes 24-25 ewt 35 afin de les fixer dynamiquement pour toute la
# session de l'utilisateur.

# Remplace /usr/local/ptimesync et /root/Startup/timesync.sh
# (s.v.p. enlever ou entreproser ailleurs) dans slacko-700_32-bits.

# Tel quel, le script devrait offrir une précision de 0,6 à 0,167
# seconde.

# J'utilise les sites du Parlement du Canada et de l'Assemblée
# Nationale du Québec comme serveurs de temps. Si la vérification
# prend trop de temps parce que ces sites sont trop éloignés, vous
# avez toute liberté de tester et utiliser d'autres sites publics ou
# gouvernmentaux plus près de chez vous.

# Ce script s'avérera utile si la batterie de votre ordi est à plat.

# IMPORTANT: Après une panne de courant ou un bris soudain du système,
# ce script pourrait refuser de s'exécuter. Pour rétablir le fonction-
# nement normal du script, ouvrez une console et tapez, exactement :
# `grep htpdate htpdate-0.3.sh | grep -v "#"`
# relancez ce script, puis redémarrez le Puppy ou Toutou.
#~~~~~~~~~~~~~~
## LICENSE GPL3 --
#  Ce programme est libre : vous pouvez le redistribuer ou modifier
#  selon les termes de la Licence Publique Générale GNU publiée par la
#  Free Software Foundation (v. 3 ou ultérieure, à votre choix).
#     Ce programme est distribué dans l'espoir qu'il sera utile, mais
#  SANS GARANTIE AUCUNE, ni explicite ni implicite, y compris des #
#  garanties de commercialisation ou d'adaptation à un but spécifique.
#  Pour plus de détails, vous reporter au texte de cette licence à
#  https://opensource.org/licenses/GPL-3.0 pour le texte officiel, à
#  une traduction à http://www.linux-france.org/article/these/gpl.html,
#  et à https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU
#  pour une explication en français.
#
################
